function TogglePane(fieldset, useDefaultStyling) {

	this.fieldset = $(fieldset);
	
	if (!this.fieldset) throw new Error("cannot find fieldset " + fieldset);
	
	if (this.fieldset.tagName != 'FIELDSET') 
		throw new Error("element is not a fieldset");
		
	this.legend = this.fieldset.getElementsByTagName('legend')[0];
	
	if (!this.legend)
		throw new Error("cannot find legend for fieldset " + fieldset);
		
	Element.addClassName(this.fieldset, 'togglePane');
	
	this.legend.onclick = (function() {
		$A(this.fieldset.childNodes).each(
			function(child) {
				if (child.nodeType == Node.ELEMENT_NODE && 
				  child.tagName != 'LEGEND') {
					Effect.toggle(child);
				}
			}
		);
	}).bind(this); // So the "this" ref will actually be to "this" and not the clicked item.
	
	if (useDefaultStyling == true) this.applyDefaultStyling(0);
}

TogglePane.prototype.applyDefaultStyling = function() {
	this.legend.style.borderWidth = '3px';
	this.legend.style.borderStyle = 'outset';
	this.legend.style.borderColor = '#888888';
	this.legend.style.backgroundColor = '#bbbbbb';
	this.legend.style.cursor = 'pointer';
	this.legend.style.paddingTop = '1px';
	this.legend.style.paddingBottom = '1px';
	this.legend.style.paddingLeft = '18px';
	this.legend.style.paddingRight = '18px';
	this.legend.style.fontSize = '0.8em';
}