window.onload=initResizeHandles;

// Page elements -- the applet, the div that it's in, and the div's resize handles.
var applet, appletDiv, rightHandle, cornerHandle, bottomHandle;
// The draggable objects wrapping the resize handles.
var dragRight, dragCorner, dragBottom;

function initResizeHandles() {
    // Initialize element variables.
    applet = $('clustering_demo_applet');
    appletDiv = $('clustering_demo_div');
    rightHandle = $('clustering_demo_right_handle');
    cornerHandle = $('clustering_demo_corner_handle');
    bottomHandle = $('clustering_demo_bottom_handle');

    var appletDivWidth = appletDiv.getWidth();
    var appletDivHeight = appletDiv.getHeight();
    
    var rightHandleWidth = rightHandle.getWidth();   
    var bottomHandleHeight = bottomHandle.getHeight();
    
    var appletWidth = appletDivWidth - rightHandleWidth;
    var appletHeight = appletDivHeight - bottomHandleHeight;
    
    applet.setStyle({
        width: appletWidth + 'px',
        height: appletHeight + 'px'
    });
   
    rightHandle.setStyle({
        left: appletWidth + 'px',
        height: appletHeight + 'px',
        display: 'block'
    });
    
    cornerHandle.setStyle({
        top: appletHeight + 'px',
        left: appletWidth + 'px',
        display: 'block'
    });
    
    bottomHandle.setStyle({
        top: appletHeight + 'px',
        width: appletWidth + 'px',
        display: 'block'
    });
    
    dragRight = new Draggable(rightHandle, {
        constraint: 'horizontal',
        change: resizeRight,
        snap: ensureMinWidth
    });
    
    dragCorner = new Draggable(cornerHandle, {
        change: resizeCorner,
        snap: function (x, y) {
            var values = ensureMinWidth(x, y);
            return ensureMinHeight(values[0], values[1]);
        }
    });
    
    dragBottom = new Draggable(bottomHandle, {
        constraint: 'vertical',
        change: resizeBottom,
        snap: ensureMinHeight
    });
}

function ensureMinWidth(x, y) {
    if (x < 200) x = 200;
    return [x, y];
}

function ensureMinHeight(x, y) {
    if (y < 200) y = 200;
    return [x, y];
}

function resizeRight(draggable) {
    var elt = draggable.element;
    setAppletWidth(elt.offsetLeft, elt);
}

function resizeCorner(draggable) {
    var elt = draggable.element;
    setAppletHeight(elt.offsetTop, elt);
    setAppletWidth(elt.offsetLeft, elt);
}

function resizeBottom(draggable) {
    var elt = draggable.element;
    setAppletHeight(elt.offsetTop, elt);
}

function setAppletWidth(x, element) {
    appletDiv.setStyle({
        width: (x+5) + 'px'
    });
    if (element != cornerHandle) {
        cornerHandle.setStyle({
            left: x + 'px'
        });
    }
    if (element != rightHandle) {
        rightHandle.setStyle({
            left: x + 'px'
        });
    }
    bottomHandle.setStyle({
        width: x + 'px'
    });
    applet.setStyle({
        width: x + 'px'
    });
}

function setAppletHeight(y, element) {
    appletDiv.setStyle({
        height: (y+5) + 'px'
    });
    if (element != cornerHandle) {
        cornerHandle.setStyle({
            top: y + 'px'
        });
    }
    rightHandle.setStyle({
        height: y + 'px'
    });
    if (element != bottomHandle) {
        bottomHandle.setStyle({
            top: y + 'px'
        });
	}
	applet.setStyle({
        height: y + 'px'
    });
}
