<?php

    # Add the name of the setup function to dynamic global array of extension function names.
    $wgExtensionFunctions[] = 'clusteringDemoSetup';

    # The function that sets up the word "clustering" as a tag extension.
    function clusteringDemoSetup() {
        global $wgParser;
        $wgParser->setHook('clustering', 'clusteringDemoRender');
    }

    # The function that renders HTML when the tag extension "clustering" is encountered. (As <clustering/>, <clustering></clustering>, etc..)
	function clusteringDemoRender($input, $args, $parser) {
        # Define the opening applet tag, common attributes, and jar files.
        $output = "<applet name='clustering_demo_applet' " .
          "id='clustering_demo_applet' code='clustering.DemoApplet' " .
          "archive='clustering_demo.jar' " .
	      "codebase='/mediawiki/extensions/clustering_demo' width='700' height='700'>\n";

        # Pass on each name-value pair in $args to the applet as an applet param.
        foreach ($args as $name => $value) {
            $output .= "  <param name='" . htmlspecialchars($name) . "' VALUE='" . htmlspecialchars($value) . "'>\n";
        }

        # Add the closing tag.
        $output .= "</applet>";

        return $output;
    }

?>
