<?php

    # Add the name of the setup function to dynamic global array of extension function names.
    $wgExtensionFunctions[] = 'clusteringDemoSetup';

    # The function that sets up the word "clustering" as a tag extension.
    function clusteringDemoSetup() {
        global $wgParser;
        $wgParser->setHook('clustering', 'clusteringDemoRender');
    }

    # The function that renders HTML when the tag extension "clustering" is encountered. (As <clustering/>, <clustering></clustering>, etc..)
	function clusteringDemoRender($input, $args, $parser) {
    	global $wgOut, $wgScriptPath;

        # Inject the stylesheet link into the head section.
        $wgOut->addScript('<link rel="stylesheet" type="text/css" href="' .
            $wgScriptPath . '/extensions/clustering_demo/css/clustering_demo.css" />');

        # Inject the open-source Javascript libraries.
        $wgOut->addScript('<script src="' . $wgScriptPath .
            '/extensions/clustering_demo/js/lib/prototype.js" type="text/javascript"></script>');
        $wgOut->addScript('<script src="' . $wgScriptPath .
            '/extensions/clustering_demo/js/lib/scriptaculous.js?load=effects,dragdrop" type="text/javascript"></script>');

        # Inject the Javascript file which sets up the resize handles.
        $wgOut->addScript('<script src="' . $wgScriptPath .
            '/extensions/clustering_demo/js/clustering_demo.js" type="text/javascript"></script>');

        # Enclose the applet in a div and don't give it width and height attributes.  They're defined in the stylesheet.
        $output =
            "<div id='clustering_demo_div'>" .
	        "<applet name='clustering_demo_applet' id='clustering_demo_applet' code='clustering.DemoApplet' archive='clustering_demo.jar' " .
	         "codebase='/mediawiki/extensions/clustering_demo'>\n";

        # Pass on each name-value pair in $args to the applet as an applet param.
        foreach ($args as $name => $value) {
            $output .= "  <param name='" . htmlspecialchars($name) . "' VALUE='" . htmlspecialchars($value) . "'>\n";
        }

        # Also include 3 divs for the resize handles.
        $output .= "</applet>" .
          "<div id='clustering_demo_right_handle'></div>" .
          "<div id='clustering_demo_corner_handle'></div>" .
          "<div id='clustering_demo_bottom_handle'></div>" .
          "</div>\n";

        return $output;
    }

?>