package clustering;

/**
 * Defines object which register with implementations <code>Clustering</code>
 * to be notified of significant events during clustering.
 */
public interface ClusteringListener {

    /**
     * A message has been received.
     * 
     * @param message
     */
    public void clusteringMessage(Clustering src, String message);
    
    /**
     * Clustering is complete.
     * 
     * @param clusters the output of clustering.
     * @param executionTime the time in milliseconds taken to cluster.
     */
    public void clusteringComplete(Clustering src, Cluster[] clusters, long executionTime);
    
    /**
     * An error occurred during clustering.
     * 
     * @param t
     */
    public void clusteringError(Clustering src, Throwable t);
    
}
